#include <SPI.h>
#include <MFRC522.h>
#include <LiquidCrystal_I2C.h>

#define SS_PIN 10
#define RST_PIN 9

MFRC522 mfrc522(SS_PIN, RST_PIN);
LiquidCrystal_I2C lcd(0x27,20,4); // Définissez les broches appropriées pour votre écran LCD

int readsuccess;

void setup() {
  lcd.init();                      // initialize the lcd 
  lcd.backlight();
  lcd.setCursor(0,0);
  Serial.begin(9600);
  SPI.begin();
  mfrc522.PCD_Init();

  lcd.begin(24, 2); // Initialisez votre écran LCD, 16 colonnes et 2 lignes
  lcd.print("Lecteur RFID pret!");
}

void loop() {
  readsuccess = getid();
  if (readsuccess) {
    lcd.clear();
    lcd.print("UID de la carte : ");
    for (byte i = 0; i < mfrc522.uid.size; i++) {
      lcd.print(mfrc522.uid.uidByte[i] < 0x10 ? " 0" : " ");
      lcd.print(mfrc522.uid.uidByte[i], HEX);
    }
    delay(2000); // Affichez les informations pendant 2 secondes
  }
}

int getid() {
  if (mfrc522.PICC_IsNewCardPresent() && mfrc522.PICC_ReadCardSerial()) {
    Serial.print("UID de la carte : ");
    for (byte i = 0; i < mfrc522.uid.size; i++) {
      Serial.print(mfrc522.uid.uidByte[i] < 0x10 ? " 0" : " ");
      Serial.print(mfrc522.uid.uidByte[i], HEX);
    }
    Serial.println();
    
    lcd.clear();
    lcd.print("Carte detectee!");
    delay(2000); // Affichez le message pendant 1 seconde

    mfrc522.PICC_HaltA();
    return 1;
  }
  return 0;
}

