#include <SPI.h>
#include <MFRC522.h>
#include <LiquidCrystal_I2C.h>

#define SS_PIN 10
#define RST_PIN 9

MFRC522 mfrc522(SS_PIN, RST_PIN);
LiquidCrystal_I2C lcd(0x27, 20, 4);

void setup() {
  lcd.init();
  lcd.backlight();
  lcd.setCursor(0, 0);
  Serial.begin(9600);
  SPI.begin();
  mfrc522.PCD_Init();
  lcd.begin(24, 2);
  lcd.print("Lecteur RFID pret!");
}

void loop() {
  if (mfrc522.PICC_IsNewCardPresent() && mfrc522.PICC_ReadCardSerial()) {
    lcd.clear();
    lcd.print("UID de la carte : ");
    for (byte i = 0; i < mfrc522.uid.size; i++) {
      lcd.print(mfrc522.uid.uidByte[i] < 0x10 ? " 0" : " ");
      lcd.print(mfrc522.uid.uidByte[i], HEX);
    }

    // Demander le nombre d'articles au client via la communication série
    Serial.println("Demande d'articles au client...");
    while (!Serial.available()) {
      // Attendre que le client entre le nombre d'articles
    }
    int nombre_articles_demande = Serial.parseInt();
    Serial.print("Nombre d'articles demandé : ");
    Serial.println(nombre_articles_demande);

    // Ajouter une pause pour laisser le temps au client de lire l'écran LCD
    delay(2000);

    // HaltA pour arrêter la carte actuelle
    mfrc522.PICC_HaltA();
  }
}


int getid() {
  if (mfrc522.PICC_IsNewCardPresent() && mfrc522.PICC_ReadCardSerial()) {
    Serial.print("UID de la carte : ");
    for (byte i = 0; i < mfrc522.uid.size; i++) {
      Serial.print(mfrc522.uid.uidByte[i] < 0x10 ? " 0" : " ");
      Serial.print(mfrc522.uid.uidByte[i], HEX);
    }
    Serial.println();

    lcd.clear();
    lcd.print("Carte detectee!");
    delay(2000);

    mfrc522.PICC_HaltA();
    return 1;
  }
  return 0;
}
