import serial
import openpyxl
from datetime import datetime

# Charger la feuille Excel
workbook = openpyxl.load_workbook("C:/Users/ptani/Dropbox/Inventory.xlsx")  
sheet = workbook.active

# Définir les entêtes si la feuille est vide
if sheet.max_row == 1:
        workbook.save("C:/Users/ptani/Dropbox/Inventory.xlsx")

def ajouter_dans_excel(rfid_uid, nom_item, nombre_article, position_article):
    """
    Ajoute les données dans la feuille Excel.

    Args:
        rfid_uid (str): UID de la carte RFID.
        nom_item (str): Nom de l'item.
        nombre_article (int): Nombre d'articles.
        position_article (str): Position de l'article (Étagère).
    """
    date_time = datetime.now().strftime("%Y-%m-%d %H:%M:%S")

    # Initialiser la nouvelle ligne
    nouvelle_ligne = [date_time.split()[0], date_time.split()[1], rfid_uid, nom_item, nombre_article, position_article]

    # Ajouter la nouvelle ligne dans la feuille Excel
    sheet.append(nouvelle_ligne)

    # Sauvegarder les modifications dans le fichier Excel
    workbook.save("C:/Users/ptani/Dropbox/Inventory.xlsx")

def saisir_informations():
    """
    Permet au client de saisir les informations.
    """
    nom_item = input("Nom de l'item : ")
    nombre_article = int(input("Nombre d'articles : "))
    position_article = input("Position de l'article (Étagère) : ")

    return nom_item, nombre_article, position_article

# Ouvrir le port série
ser = serial.Serial('COM12', 9600)  

try:
    while True:
        data = ser.readline().decode().strip()
        if data.startswith("UID de la carte :"):
            rfid_uid = data.split(":")[1].strip()  # Récupérer l'UID de la carte

            # Demander au client de saisir les informations
            nom_item, nombre_article, position_article = saisir_informations()

            # Ajouter les données dans la feuille Excel
            ajouter_dans_excel(rfid_uid, nom_item, nombre_article, position_article)
except serial.SerialException as se:
    print(f"Erreur d'ouverture du port série : {se}")
except Exception as e:
    print(f"Erreur : {e}")
finally:
    # Fermer le port série
    ser.close()


